package com.inca.npbusi.saset.bms_sa_bill;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.gui.tbar.TButton;
import com.inca.np.util.SendHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import java.awt.BorderLayout;
import java.awt.HeadlessException;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JToolBar;

public class Bms_sa_bill_master extends CMasterModel {
   public Bms_sa_bill_master(CFrame frame, CMdeModel mdemodel) throws HeadlessException {
      super(frame, "发票总单", mdemodel);
   }

   public String getTablename() {
      return "bms_bill_doc_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected JPanel createSecondtoolbar() {
      CToolbar c = new CToolbar();
      JPanel jp = new JPanel();
      jp.setLayout(new BorderLayout());
      c.add(this.getTButton("由销售结算单生成(G)", "由销售结算单生成", "由销售结算单生成", 71));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("由发票生成(S)", "由发票生成", "由发票生成", 83));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("确定(Q)", "确定", "确定", 81));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("导出金穗(O)", "导出金穗", "导出金穗", 79));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("清除导出标志(M)", "清除导出标志", "清除导出标志", 77));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("清空发票号(N)", "清空发票号", "清空发票号", 78));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("作废发票(I)", "作废发票", "作废发票", 73));
      c.add(new JToolBar.Separator());
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("发票上传金税接口(I)", "发票上传金税接口", "发票上传金税接口", 87));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("回填发票金税接口(H)", "回填发票金税接口", "回填发票金税接口", 89));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("发票回执确认(C)", "发票回执确认", "发票回执确认", 67));
      c.add(new JToolBar.Separator());
      c.add(this.getTButton("切换独立单元(A)", "切换独立单元", "切换独立单元", 65));
      c.add(new JToolBar.Separator());
      c.setBackground(c.getComponent(0).getBackground());
      jp.add(c);
      return jp;
   }

   private TButton getTButton(String txt, String tips, String cmd, int ke) {
      TButton item = new TButton(txt);
      item.setToolTipText(tips);
      item.setActionCommand(cmd);
      item.addActionListener(this.mdemodel);
      item.setMnemonic(ke);
      item.setFocusable(false);
      return item;
   }

   protected int on_new(int row) {
      Userruninfo user = ClientUserManager.getCurrentUser();
      this.setItemValue(row, "inputmanid", user.getUserid());
      this.setItemValue(row, "inputmanname", user.getUsername());
      this.setItemValue(row, "entryid", user.getEntryid());
      this.setItemValue(row, "entryname", user.getEntryname());
      this.setItemValue(row, "usestatus", "2");
      this.setItemValue(row, "credate", NpbusiDBHelper.getSysdate());
      if ("1".equals(((Bms_sa_bill_mde)this.mdemodel).getApvalue("发票号是否自动递增生成"))) {
         String billNo = this.autoCreateBillNo();
         if (billNo != null && !"".equals(billNo)) {
            this.setItemValue(row, "billno", billNo.substring(0, billNo.indexOf(",")));
            this.setItemValue(row, "billcode", billNo.substring(billNo.indexOf(",") + 1));
         }
      }

      return super.on_new(row);
   }

   private String autoCreateBillNo() {
      String userid = ClientUserManager.getCurrentUser().getUserid();
      String roleid = ClientUserManager.getCurrentUser().getRoleid();
      String empidset = null;
      String roleidset = null;
      String invoicelen = null;
      String curinvoiceno = null;
      String invoicecode = null;
      String setid = "";
      String sql = "select a.empidset,a.setid ,a.invoicelen,a.curinvoiceno,a.invoicecode from bms_invoice_no_set_v a where a.EMPIDSET is not null";
      RemotesqlHelper rsh = new RemotesqlHelper();
      DBTableModel dbt = null;

      try {
         dbt = rsh.doSelect(sql, 0, 10000);
      } catch (Exception var25) {
         Exception e = var25;
         e.printStackTrace();
      }

      int rowcount = false;
      Exception e;
      Exception e;
      int rowcount;
      int j;
      String count;
      if (dbt != null & dbt.getRowCount() > 0) {
         rowcount = dbt.getRowCount();

         for(j = 0; j < rowcount; ++j) {
            setid = dbt.getItemValue(j, "setid");
            empidset = dbt.getItemValue(j, "empidset");
            invoicelen = dbt.getItemValue(j, "invoicelen");
            curinvoiceno = dbt.getItemValue(j, "curinvoiceno");
            int length = curinvoiceno.length();
            if (curinvoiceno.length() < Integer.parseInt(invoicelen)) {
               for(int len = 0; len < Integer.parseInt(invoicelen) - length; ++len) {
                  curinvoiceno = "0" + curinvoiceno;
               }
            }

            invoicecode = dbt.getItemValue(j, "invoicecode");
            DBTableModel dbt2 = null;
            RemotesqlHelper rsh2 = new RemotesqlHelper();

            try {
               sql = "select count(1) count from dual where " + userid + " in(" + empidset + ")";
               dbt2 = rsh2.doSelect(sql, 0, 10000);
            } catch (Exception var24) {
               Exception e = var24;
               e.printStackTrace();
            }

            String count = dbt2.getItemValue(0, "count");
            if (Integer.parseInt(count) == 1) {
               break;
            }

            setid = null;
            empidset = null;
         }

         if (setid == null || "".equals(setid)) {
            try {
               sql = "select a.empidset,a.setid ,a.invoicelen,a.curinvoiceno,a.invoicecode from bms_invoice_no_set_v a where a.EMPIDSET is null and a.roleidset is not null";
               dbt = rsh.doSelect(sql, 0, 10000);
            } catch (Exception var23) {
               e = var23;
               e.printStackTrace();
            }

            if (dbt != null && !"".equals(dbt)) {
               rowcount = dbt.getRowCount();

               for(j = 0; j < rowcount; ++j) {
                  setid = dbt.getItemValue(j, "setid");
                  roleidset = dbt.getItemValue(j, "roleidset");
                  dbt.getItemValue(j, "invoicelen");
                  curinvoiceno = dbt.getItemValue(j, "curinvoiceno");
                  invoicecode = dbt.getItemValue(j, "invoicecode");
                  sql = "select count(1) count from dual where '" + roleid + "' in(" + roleidset + ")";

                  try {
                     dbt = rsh.doSelect(sql, 0, 10000);
                  } catch (Exception var22) {
                     e = var22;
                     e.printStackTrace();
                  }

                  count = dbt.getItemValue(0, "count");
                  if (Integer.parseInt(count) == 1) {
                     break;
                  }

                  setid = null;
                  roleidset = null;
               }

               if (setid == null || "".equals(setid)) {
                  this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
                  return "";
               }
            } else {
               this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
            }
         }
      } else {
         try {
            sql = "select a.empidset,a.setid,a.invoicelen,a.curinvoiceno,a.invoicecode from bms_invoice_no_set_v a where a.EMPIDSET is null and a.roleidset is not null";
            dbt = rsh.doSelect(sql, 0, 10000);
         } catch (Exception var21) {
            e = var21;
            e.printStackTrace();
         }

         if (dbt != null && !"".equals(dbt)) {
            rowcount = dbt.getRowCount();

            for(j = 0; j < rowcount; ++j) {
               setid = dbt.getItemValue(j, "setid");
               roleidset = dbt.getItemValue(j, "roleidset");
               dbt.getItemValue(j, "invoicelen");
               curinvoiceno = dbt.getItemValue(j, "curinvoiceno");
               invoicecode = dbt.getItemValue(j, "invoicecode");
               sql = "select count(1) count from dual where '" + roleid + "' in(" + roleidset + ")";

               try {
                  dbt = rsh.doSelect(sql, 0, 10000);
               } catch (Exception var20) {
                  e = var20;
                  e.printStackTrace();
               }

               count = dbt.getItemValue(0, "count");
               if (Integer.parseInt(count) == 1) {
                  break;
               }

               setid = null;
               roleidset = null;
            }

            if (setid == null || "".equals(setid)) {
               this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
               return "";
            }
         } else {
            this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
         }
      }

      ParamCommand invpc = new ParamCommand();
      ClientRequest req = new ClientRequest();
      req.addCommand(new StringCommand("生成发票信息"));
      ParamCommand pc = new ParamCommand();
      ParamCommand autoflag_pc = new ParamCommand();
      req.addCommand(new StringCommand("bms_sa_settle_dtl"));
      pc.addParam("ID_0", "1=2");
      autoflag_pc.addParam("invflag", "1");
      autoflag_pc.addParam("setid_0", setid);
      req.addCommand(pc);
      req.addCommand(invpc);
      req.addCommand(autoflag_pc);
      ServerResponse resp = null;

      try {
         resp = SendHelper.sendRequest(req);
      } catch (Exception var19) {
         Exception e = var19;
         e.printStackTrace();
      }

      StringCommand sc = (StringCommand)resp.commandAt(0);
      return !sc.getString().startsWith("+OK") ? "" : curinvoiceno + "," + invoicecode;
   }

   protected String getOtherWheres() {
      String where = super.getOtherWheres();
      if (!"".equals(where)) {
         where = where + " entryid = " + ClientUserManager.getCurrentUser().getEntryid() + " ";
      } else {
         where = " entryid = " + ClientUserManager.getCurrentUser().getEntryid() + " ";
      }

      return where;
   }

   public int on_beforesave() {
      int rows = this.mdemodel.getDetailModel().getRowCount();
      new Vector();
      String taxrate = "";
      if (rows > 0) {
         for(int i = 0; i < rows; ++i) {
            String thistaxrate = this.mdemodel.getDetailModel().getItemValue(i, "taxrate");
            if (i > 0 && !thistaxrate.equals(taxrate)) {
               this.infoMessage("提示", "发票细单中有不相同的税率。");
               break;
            }

            taxrate = thistaxrate;
         }
      }

      return super.on_beforesave();
   }

   protected String getEditablecolumns(int row) {
      String usestatus = this.mdemodel.getMasterModel().getItemValue(row, "usestatus");
      return usestatus.equals("1") ? "billno" : super.getEditablecolumns(row);
   }
}
